
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>6.5. [U4.23.04] : Operator MODI_MAILLAGE (MODIFY_MESH) &#8212; Code-Aster v14 0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/app.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/code_aster.css" />
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="6.6. [U4.24.01] : Operator DEFI_SQUELETTE" href="u4.24.01.html" />
    <link rel="prev" title="6.4. [U4.22.01] : Operator DEFI_GROUP (DEFINE_GROUP)" href="u4.22.01.html" />

<script type="text/javascript" src="../../_static/sidebar.js"></script>

<link rel="stylesheet" href="https://use.typekit.net/isi7ftn.css">
<script>try{Typekit.load({ async: true });}catch(e){}</script>
<script type="text/javascript" src="../../_static/copybutton.js"></script>


  </head><body>
<div class="topbar">
  <!--
  <a class="brand" title="Documentation Home" href="../../index.html">
    <span id="logotext">LSST Science Pipelines</span>
  </a>
  -->
  <ul>
    <li><a href="https://www.code-aster.org/V2/spip.php?rubrique19">Code Aster PDF Docs</a></li>
  </ul>
</div>

<div class="related">
    <h3>Navigation</h3>
    <ul>
      <li class="right">
	<a href="u4.24.01.html" title="6.6. [U4.24.01] : Operator DEFI_SQUELETTE">
	  next &raquo;
	</a>
      </li>
      <li class="right">
	<a href="u4.22.01.html" title="6.4. [U4.22.01] : Operator DEFI_GROUP (DEFINE_GROUP)">
	  &laquo; previous
	</a>
	 |
      </li>
      <li>
	<a href="../../index.html">Code-Aster v14 0.1 documentation</a>
	 &#187;
      </li>
      <li><a href="u4_toc.html" accesskey="U"><span class="section-number">6. </span><strong>U4</strong>: Command documentation</a> &#187;</li>
      
      <li><span class="section-number">6.5. </span><strong>[U4.23.04]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">MODI_MAILLAGE</span></code> (<span class="gray">MODIFY_MESH</span>)</li> 
    </ul>
</div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="u4-23-04-operator-modi-maillage-modify-mesh">
<span id="u4-23-04"></span><span id="index-0"></span><h1><span class="section-number">6.5. </span><strong>[U4.23.04]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">MODI_MAILLAGE</span></code> (<span class="gray">MODIFY_MESH</span>)<a class="headerlink" href="#u4-23-04-operator-modi-maillage-modify-mesh" title="Permalink to this headline">¶</a></h1>
<div class="section" id="purpose">
<span id="u4-23-04-1"></span><h2><span class="section-number">6.5.1. </span>Purpose<a class="headerlink" href="#purpose" title="Permalink to this headline">¶</a></h2>
<p>Perform modifications on an existing mesh. The possible modifications are:</p>
<ul class="simple">
<li><p>to reorient skin elements (face/edge) being used to apply a pressure,</p></li>
<li><p>to reorient the HEXA8 elements of SHB (solid shell element) models,</p></li>
<li><p>to check the orientation of the normals of shell elements,</p></li>
<li><p>to reorient the elements of a mono-layer of joint elements,</p></li>
<li><p>the recompute the nodal positions of a mesh using displacements calculated previously,</p></li>
<li><p>in an element with crack tip, to move the middle nodes of the edges touching the crack tip to
a position closer to the crack tip (to a quarter of these edges),</p></li>
<li><p>translate a mesh,</p></li>
<li><p>impose one or more rotations on a mesh,</p></li>
<li><p>generate a symmetrical mesh with respect to a plane in 3D or a straight line in 2D.</p></li>
<li><p>calculate the arc-length coordinates (called “curvilinear abscissa” in <code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code>)  along a
line formed by line elements (SEG)</p></li>
<li><p>randomly modify the coordinates of the nodes</p></li>
</ul>
<p>The output of this operator is a data structure of the <span class="green">maillage</span> type or
a modified version of the input  data structure (operator <span class="blue">reuse</span>).</p>
</div>
<div class="section" id="syntax">
<span id="u4-23-04-2"></span><h2><span class="section-number">6.5.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>mesh [maillage] = MODI_MAILLAGE
(

  ◊ reuse = / mesh,
  ♦ MAILLAGE = mesh,                                            [maillage]

  ◊ ORIE_FISSURE = _F(
                      ♦ GROUP_MA = l_gm                         [l_gr_ma]
                     ),
  ◊ ORIE_SHB = _F(
                  ♦ GROUP_MA = l_gm                             [l_gr_ma]
                 ),
  ◊ DEFORME = _F (
                  ♦ OPTION = &#39;TRAN&#39;,
                  ♦ / DEPL = depl,                              [cham_no]
                    / ALEA = epsi,                              [R]
                 ),
  ◊ ORIE_PEAU_2D = _F(
                      ♦ GROUP_MA = lgrma,                       [l_gr_ma]
                      ◊ GROUP_MA_SURF = l_gms                   [l_gr_ma]
                     ),
  ◊ ORIE_PEAU_3D = _F(
                      ♦ GROUP_MA = lgrma,                       [l_gr_ma]
                      ◊ GROUP_MA_VOLU = l_gmv                   [l_gr_ma]
                     ),
  ◊ ORIE_NORM_COQUE = _F(
                         ♦ GROUP_MA = lgrma,                    [l_gr_ma]
                         ◊ VECT_NORM = (n1, n2, [n3]),          [l_R]
                         ◊ GROUP_NO = grno,                     [gr_no]
                        ),
  ◊ ORIE_LINE = _F(
                   ♦ GROUP_MA =lgrma,                           [l_gr_ma]
                   ◊ VECT_TANG = (n1, n2, [n3]),                [l_R]
                   ◊ GROUP_NO = grno,                           [gr_no]
                  ),
  ◊ MODI_MAILLE= _F(
                    ♦ OPTION = &#39;NOEUD_QUART&#39;,
                    ♦ / GROUP_MA_FOND = lgma_fo,                [l_gr_ma]
                      / GROUP_NO_FOND = lgno_fo,                [l_gr_no]
                   ),
  ◊ TRANSLATION = (n1, n2, [n3]),                               [l_R]
  ◊ ROTATION = _F(
                  ♦ POIN_1 = (n1, n2, [n3]),                    [l_R]
                  ♦ / POIN_2 = (n1, n2, [n3]),                  [l_R]
                    / DIR = (n1, n2, [n3]),                     [l_R]
                  ♦ ANGLE = / theta,                            [R]
                            / 0.,                               [DEFAULT]),
  ◊ ECHELLE = n1,                                               [R]
  ◊ MODI_BASE = _F(
                   ♦ VECT_X = (n1, n2, [n3]),                   [l_R]
                   ◊ VECT_Y = (n1, n2, [n3]),                   [l_R]
                  ),
  ◊ SYMETRIE = _F(
                  ♦ POINT = (n1, n2, [n3]),                     [l_R]
                  ♦ AXE_1 = (n1, n2, [n3]),                     [l_R]
                  ◊ AXE_2 = (n1, n2, n3),                       [l_R]
                 ),
  ◊ ABSC_CURV = _F(
                   ♦ / TOUT = &#39;OUI&#39;,
                     / GROUP_MA = (gm1, gm2, ...),              [l_gr_ma]
                   ♦ GROUP_NO_ORIG = gnorig,                    [gr_no]
                  ),
  ◊ INFO = / 1,                                                 [DEFAULT]
           / 2,
)
</pre></div>
</div>
</div>
<div class="section" id="operands">
<span id="u4-23-04-3"></span><h2><span class="section-number">6.5.3. </span>Operands<a class="headerlink" href="#operands" title="Permalink to this headline">¶</a></h2>
<div class="section" id="operands-maillage-mesh">
<span id="u4-23-04-3-1"></span><h3><span class="section-number">6.5.3.1. </span>Operands <span class="blue">MAILLAGE</span> (<span class="gray">MESH</span>)<a class="headerlink" href="#operands-maillage-mesh" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ | MAILLAGE = mesh
</pre></div>
</div>
<p>Mesh of type <span class="green">[maiiage]</span> on which the modifications and / or checks will be performed.</p>
</div>
<div class="section" id="operand-info">
<span id="u4-23-04-3-2"></span><h3><span class="section-number">6.5.3.2. </span>Operand <span class="blue">INFO</span><a class="headerlink" href="#operand-info" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ INFO =
</pre></div>
</div>
<p>Indicates the amount of output to be printed in the message file (of the operator’s results).</p>
<ul class="simple">
<li><p><span class="blue">1</span> = no printing,</p></li>
<li><p><span class="blue">2</span> = printing of the elements whose connectivity has been modified, including the printing of
old and new connectivity.</p></li>
</ul>
</div>
<div class="section" id="keyword-orie-fissure-orient-crcak">
<span id="u4-23-04-3-3"></span><h3><span class="section-number">6.5.3.3. </span>Keyword <span class="blue">ORIE_FISSURE</span> (<span class="gray">ORIENT_CRCAK</span>)<a class="headerlink" href="#keyword-orie-fissure-orient-crcak" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ORIE_FISSURE =
</pre></div>
</div>
<p>This key word is used to reorient (if necessary) the elements of a group forming a “single layer”
of elements. It works in 2D or 3D, with a linear or quadratic mesh (<a class="reference internal" href="#fig-u4-23-04-3-3-a"><span class="std std-numref">Fig. 6.5.1</span></a>).</p>
<div class="figure align-center" id="id1">
<span id="fig-u4-23-04-3-3-a"></span><a class="reference internal image-reference" href="../../_images/fig1_u4.23.04.png"><img alt="../../_images/fig1_u4.23.04.png" src="../../_images/fig1_u4.23.04.png" style="height: 200px;" /></a>
<p class="caption"><span class="caption-number">Fig. 6.5.1 </span><span class="caption-text">A single layer of elements.</span><a class="headerlink" href="#id1" title="Permalink to this image">¶</a></p>
</div>
<p>Currently, this keyword is used to reorient joint and interface elements (models
<span class="blue">AXIS_xxx</span>, <span class="blue">PLAN_xxx</span> and <span class="blue">3D_xxx</span> with <span class="blue">xxx = JOINT</span> or <span class="blue">INTERFACE</span>).</p>
<p>The user specifies (with the keyword <span class="blue">GROUP_MA</span>) which are the candidate elements for the
reorientation (the “single layer”).</p>
<p>These elements must be “prisms” (QUAD in 2D, HEXA and PENTA in 3D).</p>
<p>The direction “transverse” to the layer is determined topologically (and not according to a flatness
criterion). To be able to be reoriented, the elements of the layer must be supported (via the bases of
the prisms) on other meshes of the same dimension (2D or 3D) which do not belong to the group of elements
(that are to be reoriented).</p>
<p>Consider the situation where we wish to reorient the group of three elements A, B and C in the figure
below.</p>
<a class="reference internal image-reference" href="../../_images/fig2_u4.23.04.png"><img alt="../../_images/fig2_u4.23.04.png" class="align-center" src="../../_images/fig2_u4.23.04.png" style="height: 300px;" /></a>
<p>For elements A and B, the supporting elements (above and below) determine an unambiguous transverse
orientation (vertical). On the other hand, element C has three supporting elements (up, down, right)
and we do not know how to determine the transverse direction. The reorintation algorithm will fail.</p>
<div class="admonition-remark admonition">
<p class="admonition-title">Remark</p>
<p>The “reorientation” we are talking about here is actually changing the definition of element
connectivity. For example, in 2D, the convention is that sides 2 and 4 of quadrangles are transverse
to the layer.</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ GROUP_MA = l_gm,
</pre></div>
</div>
<p>List of the element groups for which one wishes to checking (and possibly modify) the orientation.</p>
</div>
<div class="section" id="keyword-orie-shb-orient-sbh-elements">
<span id="u4-23-04-3-4"></span><h3><span class="section-number">6.5.3.4. </span>Keyword <span class="blue">ORIE_SHB</span> (<span class="gray">ORIENT_SBH_ELEMENTS</span>)<a class="headerlink" href="#keyword-orie-shb-orient-sbh-elements" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ORIE_SHB =
</pre></div>
</div>
<p>The purpose of this factor keyword is to correctly reorient the volume meshes of the SHB finite elements.
It is necessary to modify the local classification of the nodes of the elements to be able to recognize
the direction of the normal to the shell.</p>
<p>The connectivity of the elements is thus possibly modified by this operator.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ GROUP_MA = l_gm,
</pre></div>
</div>
<p>List of the element groups for which one wishes to modify the orientation.</p>
</div>
<div class="section" id="keyword-deforme-displace-mesh">
<span id="u4-23-04-3-5"></span><h3><span class="section-number">6.5.3.5. </span>Keyword <span class="blue">DEFORME</span> (<span class="gray">DISPLACE_MESH</span>)<a class="headerlink" href="#keyword-deforme-displace-mesh" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ DEFORME
  / OPTION = &#39;TRAN&#39;
</pre></div>
</div>
<p>This option allows the user to modify the initial geometry of the mesh (<span class="green">mesh</span>) by :</p>
<ul class="simple">
<li><p>the translated (<span class="blue">TRAN</span>) values <span class="math notranslate nohighlight">\((dx, dy, (dz))\)</span> of the displacement field
<span class="green">depl</span> given by the keyword <span class="blue">DEPL</span>;</p></li>
<li><p>a random amount.</p></li>
</ul>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">DEPL</span> <span class="o">=</span> <span class="n">depl</span><span class="p">,</span>
</pre></div>
</div>
<p>Displacement field used to update the geometry</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="n">ALEA</span> <span class="o">=</span> <span class="n">epsi</span><span class="p">,</span>
</pre></div>
</div>
<p>In this case, a random quantity (<span class="math notranslate nohighlight">\(\Delta\)</span>) is added to each coordinate of each node of the mesh.
This quantity is obtained by the formula:</p>
<div class="math notranslate nohighlight">
\[\Delta = \text{epsi} \times \text{dim} \times \text{alea} ()\]</div>
<p>where</p>
<ul class="simple">
<li><p><span class="green">epsi</span> is a number supplied by the user (1.e-8 for example)</p></li>
<li><dl class="simple">
<dt><span class="green">dim</span> is the dimension of the mesh in the direction concerned, determined</dt><dd><p>by the component (X, Y or Z)</p>
</dd>
</dl>
</li>
<li><p><span class="green">alea()</span> is a function returning a pseudo-random number in the interval [-1.1].</p></li>
</ul>
<div class="admonition-remark admonition">
<p class="admonition-title">Remark</p>
<p>The possibility of randomly modifying the coordinates of a mesh is, a priori, a “developer”
functionality. It is dangerous in certain situations: very flat meshes (joints, …)</p>
</div>
</div>
<div class="section" id="keywords-orie-peau-2d-orie-peau-3d-orient-skin-2d-orient-skin-3d">
<span id="u4-23-04-3-6"></span><h3><span class="section-number">6.5.3.6. </span>Keywords <span class="blue">ORIE_PEAU_2D / ORIE_PEAU_3D</span> (<span class="gray">ORIENT_SKIN_2D/ORIENT_SKIN_3D</span>)<a class="headerlink" href="#keywords-orie-peau-2d-orie-peau-3d-orient-skin-2d-orient-skin-3d" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ORIE_PEAU_2D =
◊ ORIE_PEAU_3D =
</pre></div>
</div>
<p>These keywords are used to reorient edges and faces so that their normals are coherent (towards the
exterior of a body). This is an essential prerequisite if, for example, we wants to apply a pressure load
on this “skin”.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ GROUP_MA = lgrma,                [l_gr_ma]
</pre></div>
</div>
<p>Element groups that are to be reoriented.</p>
<p>The elements are directed in such a way that the normal is outgoing. For each skin element (edge or
face), one seeks the “volume” mesh that it “borders”. We orient it in such a way that its normal is
of direction opposite to the vector connecting its first node to the barycenter of the volume mesh.</p>
<p>It sometimes happens that the “skin” that you want to orient is inserted into the material (for example,
when a calculation is made for which elements may be gradually added or removed from the model: modeling
an excavation, or a layered construction). The orientation algorithm described above then fails because
one generally finds two volume elements on both sides of the skin mesh. We do not know which one to use
for orienting the skin mesh.</p>
<p>To address that problem, we introduced the optional keyword <span class="blue">GROUP_MA_VOLU</span>
(<span class="gray">VOLUME_ELEMENT_GROUP</span>) (or <span class="blue">GROUP_MA_SURF</span> <span class="gray">(SURFACE_ELEMENT_GROUP)</span> in 2D). These
keywords allow the user to specify which are the “volume” elements that are to be used to orient skin
elements.</p>
<p>Example :</p>
<p>Suppose we have a group of skin elements (<span class="green">GPEAU</span>) which we want to reorient with a normal
directed towards the outside of the body. It should be indicated that this is the skin of the “volume”
element group <span class="green">GV2</span>. We will write:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">ORIE_PEAU_2D</span> <span class="o">=</span> <span class="n">_F</span><span class="p">(</span><span class="n">GROUP_MA</span> <span class="o">=</span> <span class="s1">&#39;GPEAU&#39;</span><span class="p">,</span>
                  <span class="n">GROUP_MA_SURF</span> <span class="o">=</span> <span class="s1">&#39;GV2&#39;</span><span class="p">)</span>
</pre></div>
</div>
<a class="reference internal image-reference" href="../../_images/fig3_u4.23.04.png"><img alt="../../_images/fig3_u4.23.04.png" class="align-center" src="../../_images/fig3_u4.23.04.png" style="height: 200px;" /></a>
</div>
<div class="section" id="keyword-orie-norm-coque-orient-shell-normal">
<span id="u4-23-04-3-7"></span><h3><span class="section-number">6.5.3.7. </span>Keyword <span class="blue">ORIE_NORM_COQUE</span> (<span class="gray">ORIENT_SHELL_NORMAL</span>)<a class="headerlink" href="#keyword-orie-norm-coque-orient-shell-normal" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ORIE_NORM_COQUE = _F()
</pre></div>
</div>
<p>This keyword is used to check that in a list of surface elements (shells), the normals are consistent
with each other. Otherwise, certain elements are reoriented.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ GROUP_MA = lgrma,            [l_gr_ma]
</pre></div>
</div>
<p>Surface element groups to reorient. The elements of <span class="green">lgrma</span> must form a “connected” group
so that we can reorient them by continuity.</p>
<p>One can impose the direction of orientation using keywords <span class="blue">GROUP_NO / VECT_NORM</span>.  Otherwise,
the orientation selected will be that of the first mesh of <span class="green">lgrma</span>.  Since this is not necessarily
the correct orientation, it is advised to always use the keyword <span class="blue">VECT_NORM</span> (<span class="gray">NORMAL_VECTOR</span>).</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ VECT_NORM = (n1, n2, [n3]),               [l_R]
</pre></div>
</div>
<p><span class="green">ni</span>: 2 or 3 components (depending on the dimension) of the normal vector. It is also necessary to
specify the base node of this normal vector:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ GROUP_NO = grno,                          [gr_no]
</pre></div>
</div>
<p><span class="green">grno</span> must be a node group containing only one node. The selected normal will be that which
makes an acute angle with the vector given by <span class="blue">VECT_NORM</span>.</p>
</div>
<div class="section" id="keyword-orie-ligne-orient-line">
<span id="u4-23-04-3-8"></span><h3><span class="section-number">6.5.3.8. </span>Keyword <span class="blue">ORIE_LIGNE</span> (<span class="gray">ORIENT_LINE</span>)<a class="headerlink" href="#keyword-orie-ligne-orient-line" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ORIE_LIGNE = _F()
</pre></div>
</div>
<p>This keyword is used to check that in a list of line elements (beams), the tangents are consistent with
each other. Otherwise, certain elements are reoriented.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ GROUP_MA = lgrma,              [l_gr_ma]
</pre></div>
</div>
<p>Groups of line elements to be reoriented. The elements in <span class="green">lgrma</span> must form a “connected”
group so that we can reorient them by continuity.</p>
<p>One can impose the direction of orientation using keywords <span class="blue">GROUP_NO / VECT_TANG</span>.
Otherwise, the orientation will be that of the first element of <span class="green">lgrma</span>. Since the preferred
orientation is not necessarily that of the first element of the element group, it is advisable to always
use the keyword <span class="blue">VECT_TANG</span> (<span class="gray">TANGENT_VECTOR</span>).</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ VECT_TANG = (n1, n2, [n3]),     [l_R]
</pre></div>
</div>
<p><span class="green">ni</span>: 2 or 3 components (according to the dimension) of the tangent vector. It is also necessary
to specify the support node of the normal vector:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ GROUP_NO = grno,                [gr_no]
</pre></div>
</div>
<p><span class="green">grno</span> must be a node group containing only one node. The selected tangent will be that which makes
an acute angle with the vector given by <span class="blue">VECT_TANG</span>.</p>
</div>
<div class="section" id="keyword-modi-maille-modify-elements">
<span id="u4-23-04-3-9"></span><h3><span class="section-number">6.5.3.9. </span>Keyword <span class="blue">MODI_MAILLE</span> (<span class="gray">MODIFY_ELEMENTS</span>)<a class="headerlink" href="#keyword-modi-maille-modify-elements" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ OPTION = &#39;NOEUD_QUART&#39;,
  ♦ / GROUP_MA_FOND = lgma_fo,                    [l_gr_ma]
    / GROUP_NO_FOND = lgno_fo,                    [l_gr_no]
</pre></div>
</div>
<p>This is used to move the middle nodes of the edges of an element touching a crack tip to a quarter of
these edges (towards the crack tip) (<span class="gray">QUARTER_NODE</span>).</p>
<p>In 2D, one specifies the node of the crack tip with <span class="blue">GROUP_NO_FOND</span> (<span class="gray">NODE_GROUP_CRACK_TOP</span>).</p>
<p>In 3D, one specifies either the nodes of the crack tip, or the SEG3 elements of the crack tip (and not
the elements of the faces of the crack or the elements at the crack tip).</p>
</div>
<div class="section" id="keyword-translation">
<span id="u4-23-04-3-10"></span><h3><span class="section-number">6.5.3.10. </span>Keyword <span class="blue">TRANSLATION</span><a class="headerlink" href="#keyword-translation" title="Permalink to this headline">¶</a></h3>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This functionality can be used in combination with <span class="blue">ROTATION</span>, but these operations are
not commutative.  The translation is always executed before the rotation.  One cannot combine this
functionality with <span class="blue">SYMETRIE</span> (<span class="gray">SYMMETRY</span>).</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ TRANSLATION = (n1, n2, [n3]),                    [l_R]
</pre></div>
</div>
<p>Keyword for the translation of a mesh using a vector.</p>
</div>
<div class="section" id="keyword-rotation">
<span id="u4-23-04-3-11"></span><h3><span class="section-number">6.5.3.11. </span>Keyword <span class="blue">ROTATION</span><a class="headerlink" href="#keyword-rotation" title="Permalink to this headline">¶</a></h3>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This functionality can be used in combination with <span class="blue">TRANSLATION</span>, but these operations are
not commutative. On the other hand, you cannot use <span class="blue">ROTATION</span>, <span class="blue">MODI_BASE</span> and
<span class="blue">SYMETRIE</span> at the same time. The translation is always executed before the rotation.</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ROTATION =
</pre></div>
</div>
<p>Keyword factor for the rotation of a mesh.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ POIN_1 = (ni, n2, [n3]),                        [l_R]
</pre></div>
</div>
<p>Coordinates of the first point that defines the axis of rotation.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ / POIN_2 = (ni, n2, [n3]),                      [l_R]
  / DIR = (ni, n2, [n3]),                         [l_R]
</pre></div>
</div>
<p>Coordinates of the second point or direction that is needed to completely define the axis of rotation.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ ANGLE = theta,                                  [R]
</pre></div>
</div>
<p>Angle of rotation expressed in degrees.</p>
<p>The rotation is done in the clockwise direction, with respect to its oriented axis. This axis passes
through the point <span class="blue">POIN_1</span> and its orientation is given either by the vector <span class="blue">DIR</span> or by
the start point <span class="blue">POIN_1</span> and end point <span class="blue">POIN_2</span>.</p>
<p>The rotation is defined as follows.</p>
<p>Let <span class="math notranslate nohighlight">\(\mathbf{M}(x, y, z)\)</span> be a point in space, we impose a rotation of angle <span class="math notranslate nohighlight">\(\theta\)</span>
(in radians) around the axis passing through <span class="math notranslate nohighlight">\(\mathbf{P}(p_x, p_y, p_z)\)</span> and in the direction
<span class="math notranslate nohighlight">\(\mathbf{D}(d_x, d_y, d_z)\)</span>. So, after rotation,  <span class="math notranslate nohighlight">\(\mathbf{M}\)</span> becomes <span class="math notranslate nohighlight">\(\mathbf{M}'\)</span>
where:</p>
<div class="math notranslate nohighlight">
\[\mathbf{M}' = \mathbf{P} + \cos\theta \mathbf{PM} +
  (1 − \cos\theta) (\mathbf{PM} \cdot \mathbf{D} ) \mathbf{D} +
  \sin\theta ( \mathbf{D} \wedge \mathbf{PM} )\]</div>
</div>
<div class="section" id="keyword-echelle-scale">
<span id="u4-23-04-3-12"></span><h3><span class="section-number">6.5.3.12. </span>Keyword <span class="blue">ECHELLE</span> (<span class="gray">SCALE</span>)<a class="headerlink" href="#keyword-echelle-scale" title="Permalink to this headline">¶</a></h3>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This functionality can be used in combination with <span class="blue">ROTATION</span> and
<span class="blue">TRANSLATION</span>.  Scaling, when it is requested, is always done after <span class="blue">TRANSLATION</span> and
<span class="blue">ROTATION</span>.</p>
<p>One cannot combine this functionality with <span class="blue">SYMETRIE</span> (<span class="gray">SYMMETRY</span>).</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ECHELLE = n1,                               [R]
</pre></div>
</div>
<p>Keyword for the scaling of a mesh by a real number.</p>
<p>Let <span class="math notranslate nohighlight">\(\mathbf{M}(x, y, z)\)</span> be a point on the mesh.  The scaling operation transforms this
point to one with the coordinates scaled by the transformation ratio <span class="green">n1</span> to
<span class="math notranslate nohighlight">\(\mathbf{M}' (n1 \times x, n1 \times  y, n1 \times  z )\)</span>.</p>
</div>
<div class="section" id="keyword-modi-base-modify-basis-vectors">
<span id="u4-23-04-3-13"></span><h3><span class="section-number">6.5.3.13. </span>Keyword <span class="blue">MODI_BASE</span> (<span class="gray">MODIFY_BASIS_VECTORS</span>)<a class="headerlink" href="#keyword-modi-base-modify-basis-vectors" title="Permalink to this headline">¶</a></h3>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This functionality is unavailable in combination with <span class="blue">ROTATION</span> and
<span class="blue">SYMETRIE</span> (<span class="gray">SYMMETRY</span>).</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ MODI_BASE =
</pre></div>
</div>
<p>Keyword factor for changing the basis vectors in which one expresses the coordinates of a mesh. The
change of reference always takes place between two orthonormal bases.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ VECT_X = (n1, n2, [n3]),                        [l_R]
</pre></div>
</div>
<p>The first vector of the new basis.  Any length is allowed.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ VECT_Y = (n1, n2, [n3]),                        [l_R]
</pre></div>
</div>
<p>The second vector of the new basis (not used in 2D), also of arbitrary (but finite) length.</p>
<p>In 2D, it is enough to provide the axis <span class="blue">VECT_X</span>, and <code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code> automatically builds the
second vector to define a direct orthogonal basis. A test checks if <span class="blue">VECT_X</span> is not of zero length.</p>
<p>In 3D, one checks that <span class="blue">VECT_X</span> and <span class="blue">VECT_Y</span> are of non-zero norm and one checks that they
are orthogonal. The third vector which completes the basis is constructed as the product vector of
<span class="blue">VECT_X</span> with <span class="blue">VECT_Y</span>. We thus ensure the construction of an orthogonal basis.</p>
<p>Then, in all the cases (2D and 3D), the vectors of the basis are normalized to 1, the user does not have
to worry about it. We therefore finally have an orthonormal basis.</p>
</div>
<div class="section" id="keyword-symetrie-symmetry">
<span id="u4-23-04-3-14"></span><h3><span class="section-number">6.5.3.14. </span>Keyword <span class="blue">SYMETRIE</span> (<span class="gray">SYMMETRY</span>)<a class="headerlink" href="#keyword-symetrie-symmetry" title="Permalink to this headline">¶</a></h3>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This functionality cannot be combined with <span class="blue">TRANSLATION</span>, <span class="blue">ROTATION</span>,
<span class="blue">ECHELLE</span> (<span class="gray">SCALE</span>) and <span class="blue">MODI_BASE</span>.</p>
</div>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ POINT = (n1, n2, [n3])                     [l_R]
</pre></div>
</div>
<p>Coordinates of a point belonging to the line in 2D or to the plane in 3D.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>♦ AXE_1 = (n1, n2, [n3])                     [l_R]
</pre></div>
</div>
<p>Direction vector of the line in 2D or the first basis vector that is used to describe the plane.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ AXE_2 =(n1, n2, n3)                        [l_R]
</pre></div>
</div>
<p>Second vector that is used to describe the plane.</p>
<p>In 2D, the symmetry operation is performed with respect to a line which is in the OXY plane. To define
this line, it is necessary to provide the direction vector of the line (<span class="blue">AXE_1</span>) and a point
(<span class="blue">POINT</span>) belonging to this line.</p>
<p>In 3D, the symmetry operation is performed with respect to a plane. To define this plane, it is
necessary to provide two vectors of the plane <span class="blue">(AXE_1, AXE_2)</span> and a point (<span class="blue">POINT</span>)
belonging to this plane.</p>
<p>In all the cases (2D or 3D), the symmetry operation is carried out with respect to a plane. In 2D, the
second vector necessary for the definition of the plane is fixed at <span class="blue">AXE_2 = (0.0, 0.0, -1.0)</span>.</p>
<p>The algebraic distance
<span class="math notranslate nohighlight">\(\delta\)</span> between a point <span class="math notranslate nohighlight">\(\mathbf{M}(x, y, z)\)</span> and a plane passing through the point
<span class="math notranslate nohighlight">\(\mathbf{O}(x_0, y_0, z_0)\)</span> with for perpendicular vector
<span class="math notranslate nohighlight">\(\mathbf{V} = \text{AXE_1}~\wedge~\text{AXE_2} = (a, b, c)\)</span> is:</p>
<div class="math notranslate nohighlight">
\[\delta = \frac{a ( x - x_0 )+ b ( y - y_0 )+ c ( z - z_0 )}{\sqrt{ a^2+ b^2+ c^2}}\]</div>
<p>The coordinates of the point <span class="math notranslate nohighlight">\(\mathbf{M}'\)</span> that is symmetrical to the point <span class="math notranslate nohighlight">\(\mathbf{M}\)</span>
relative to the plane are given by:</p>
<div class="math notranslate nohighlight">
\[\mathbf{OM}' = −2\delta \frac{\mathbf{V}}{\| \mathbf{V} \|} + \mathbf{OM}\]</div>
</div>
<div class="section" id="keyword-abs-curv-arclength-coordinate">
<span id="u4-23-04-3-15"></span><h3><span class="section-number">6.5.3.15. </span>Keyword <span class="blue">ABS_CURV</span> (<span class="gray">ARCLENGTH_COORDINATE</span>)<a class="headerlink" href="#keyword-abs-curv-arclength-coordinate" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ ABS_CURV = _F(...),
</pre></div>
</div>
<p>Calculate the arc-length coordinate (called “curvilinear abscissa” in <code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code>)
for all the SEG elements provided via the keywords <span class="blue">GROUP_MA</span> or <span class="blue">TOUT = ‘OUI’</span>.</p>
<p>For each of the nodes of the elements concerned, one calculates its curvilinear abscissa by taking into
account ts possible curvature.</p>
<p>The keyword <span class="blue">GROUP_NO_ORIG</span> allows the user to choose the origin of the curvilinear abscissas
(the node where the abscissa is zero). The origin must be one of the ends of the line on which we
wish to calculate the curvilinear abscissa.</p>
<p>This option is necessary, for example, to carry out a modal calculation for a tube with an external
and an internal fluid load, when the density of the external fluid is defined as a function of the
curvilinear abscissa.</p>
<a class="reference internal image-reference" href="../../_images/fig4_u4.23.04.png"><img alt="../../_images/fig4_u4.23.04.png" class="align-center" src="../../_images/fig4_u4.23.04.png" style="height: 300px;" /></a>
<div class="admonition-remarks admonition">
<p class="admonition-title">Remarks :</p>
<ul class="simple">
<li><p>All the elements involved must be of the type SEG2, SEG3 or SEG4.</p></li>
<li><p>Elements of the type SEG2 are considered to be straight and elements SEG3 and SEG4 are
assumed to be in the form of an arc of a circle.</p></li>
</ul>
</div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<form action="../../search.html" method="get">
  <input class='c-searchbox' type="text" name="q" placeholder="Search" />
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form><div>
   <h3>Quick search</h3>
   <script async src="https://cse.google.com/cse.js?cx=1913d02e421931d61"></script>
   <div class="gcse-search"></div>
</div><h3>On this page</h3>
<ul>
<li><a class="reference internal" href="#">6.5. <strong>[U4.23.04]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">MODI_MAILLAGE</span></code> (<span class="gray">MODIFY_MESH</span>)</a><ul>
<li><a class="reference internal" href="#purpose">6.5.1. Purpose</a></li>
<li><a class="reference internal" href="#syntax">6.5.2. Syntax</a></li>
<li><a class="reference internal" href="#operands">6.5.3. Operands</a><ul>
<li><a class="reference internal" href="#operands-maillage-mesh">6.5.3.1. Operands <span class="blue">MAILLAGE</span> (<span class="gray">MESH</span>)</a></li>
<li><a class="reference internal" href="#operand-info">6.5.3.2. Operand <span class="blue">INFO</span></a></li>
<li><a class="reference internal" href="#keyword-orie-fissure-orient-crcak">6.5.3.3. Keyword <span class="blue">ORIE_FISSURE</span> (<span class="gray">ORIENT_CRCAK</span>)</a></li>
<li><a class="reference internal" href="#keyword-orie-shb-orient-sbh-elements">6.5.3.4. Keyword <span class="blue">ORIE_SHB</span> (<span class="gray">ORIENT_SBH_ELEMENTS</span>)</a></li>
<li><a class="reference internal" href="#keyword-deforme-displace-mesh">6.5.3.5. Keyword <span class="blue">DEFORME</span> (<span class="gray">DISPLACE_MESH</span>)</a></li>
<li><a class="reference internal" href="#keywords-orie-peau-2d-orie-peau-3d-orient-skin-2d-orient-skin-3d">6.5.3.6. Keywords <span class="blue">ORIE_PEAU_2D / ORIE_PEAU_3D</span> (<span class="gray">ORIENT_SKIN_2D/ORIENT_SKIN_3D</span>)</a></li>
<li><a class="reference internal" href="#keyword-orie-norm-coque-orient-shell-normal">6.5.3.7. Keyword <span class="blue">ORIE_NORM_COQUE</span> (<span class="gray">ORIENT_SHELL_NORMAL</span>)</a></li>
<li><a class="reference internal" href="#keyword-orie-ligne-orient-line">6.5.3.8. Keyword <span class="blue">ORIE_LIGNE</span> (<span class="gray">ORIENT_LINE</span>)</a></li>
<li><a class="reference internal" href="#keyword-modi-maille-modify-elements">6.5.3.9. Keyword <span class="blue">MODI_MAILLE</span> (<span class="gray">MODIFY_ELEMENTS</span>)</a></li>
<li><a class="reference internal" href="#keyword-translation">6.5.3.10. Keyword <span class="blue">TRANSLATION</span></a></li>
<li><a class="reference internal" href="#keyword-rotation">6.5.3.11. Keyword <span class="blue">ROTATION</span></a></li>
<li><a class="reference internal" href="#keyword-echelle-scale">6.5.3.12. Keyword <span class="blue">ECHELLE</span> (<span class="gray">SCALE</span>)</a></li>
<li><a class="reference internal" href="#keyword-modi-base-modify-basis-vectors">6.5.3.13. Keyword <span class="blue">MODI_BASE</span> (<span class="gray">MODIFY_BASIS_VECTORS</span>)</a></li>
<li><a class="reference internal" href="#keyword-symetrie-symmetry">6.5.3.14. Keyword <span class="blue">SYMETRIE</span> (<span class="gray">SYMMETRY</span>)</a></li>
<li><a class="reference internal" href="#keyword-abs-curv-arclength-coordinate">6.5.3.15. Keyword <span class="blue">ABS_CURV</span> (<span class="gray">ARCLENGTH_COORDINATE</span>)</a></li>
</ul>
</li>
</ul>
</li>
</ul>


        </div>
      </div>
      <div class="clearer"></div>
    </div>
<footer class="footer">
  <p class="pull-right">
    <a href="../../_sources/docs/user/u4.23.04.rst.txt"
       rel="nofollow">Page Source</a> &nbsp;
    <a href="#">Back to Top</a></p>
  <p>
  </p>
  <p>
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 3.5.1. Page design is based on <a href="https://project.lsst.org">LSST</a> created modifications of Astropy's bootstrap-astropy theme in <a href="https://github.com/astropy/astropy-helpers">astropy-helpers</a>. <br />
  </p>
  <p>
    &copy; Copyright 2021, Biswajit Banerjee.  Original version &copy; Copyright 2019 EDF R&amp;D - Licensed under the terms of the GNU FDL (http://www.gnu.org/copyleft/fdl.html).<br/>
  </p>
</footer>
  </body>
</html>